package laboratoire4;

public abstract class Pawn {
    protected final PawnColor color;
    protected int col;
    protected int row;

    public Pawn(PawnColor color, int col, int row) {
        this.color = color;
        this.col = col;
        this.row = row;
    }

    public PawnColor getColor() {
        return color;
    }

    public int getCol() {
        return col;
    }

    public int getRow() {
        return row;
    }

    public void setCol(int col) {
        this.col = col;
    }

    public void setRow(int row) {
        this.row = row;
    }

    public abstract boolean isMoveValid(PusherBoard board, PawnMovement movement);

    enum PawnColor {
        RED,
        BLACK
    }

    enum PawnMovement {
        STRAIGHT(0),
        LEFT_DIAGONAL(-1),
        RIGHT_DIAGONAL(1);

        private final int move;

        PawnMovement(int move) {
            this.move = move;
        }

        public int getMove() {
            return move;
        }
    }
}
